#!/usr/bin/env ruby
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version. This program is distributed in the hope that
# it will be useful, but WITHOUT ANY WARRANTY; without even the implied
# warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See
# the GNU General Public License for more details. You should have
# received a copy of the GNU General Public License along with this
# program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place - Suite 330, Boston, MA 02111-1307, USA.
# 
# Log in to gmail and get a count of the number of new unread 
# emails waiting
#
# Based on: http://tvg.ca/files/gmail.phps
# 

require 'net/https'
require 'cgi'

class GMailConnection

 private

 def postdata_to_string(postdata)
	postdata_string = ''

	postdata.each_pair do |key, val|
		if postdata_string.length > 0
			postdata_string += '&'
		end
		postdata_string += "#{key}=#{CGI::escape(val)}"
	end

	postdata_string
 end

 def login
	postdata = {
		"Email" => @username,
		"Passwd" => @password,
		"null" => "Sign in",
		"service" => "mail",
	}

	@conn = Net::HTTP.new('gmail.google.com', 443)
	@conn.use_ssl = true

	resp, data = @conn.post('/accounts/ServiceLoginBoxAuth', 
			       postdata_to_string(postdata), nil)

	resp['set-cookie'] =~ /(SID\=.*?\=)/

	@cookie = $1

	if data !~ /var cookieVal= \"(.*?)\"/ then
		raise "Login failed"
	end

	@cookie += "; GV=#{$1}"
 end

 public
 
 def initialize(username, password)
	@username = username
	@password = password
	login
 end

 def get_page(page)
	headers = {
		"Cookie" => @cookie
	}

	resp, data = @conn.get(page, headers)

	data
 end

 def check_mail
	s = get_page("/gmail?search=adv&as_subset=unread&view=tl&start=0")

	if s !~ /Search results for: is:unread.*?(\d+)\]/ then
		raise "Error checking mail"
	end

	$1.to_i
 end

end

